"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var presets_exports = {};
__export(presets_exports, {
  getPresetChain: () => getPresetChain
});
module.exports = __toCommonJS(presets_exports);
var import_utils = require("@modern-js/utils");
var import_babel_chain = require("./babel-chain");
const es6BrowserList = [
  "chrome >= 61",
  "edge >= 16",
  "firefox >= 60",
  "safari >= 11",
  "ios_saf >= 11"
];
const getPresetOptions = (options) => typeof options === "object" ? options : {};
const getPresetChain = (option) => {
  const { appDirectory, presets: { envOptions, reactOptions, typescriptOptions } = {}, syntax = "es5", type = "module", runEnvironments = "browsers", jsxTransformRuntime = "automatic", useTsLoader = false, overrideBrowserslist } = option;
  const chain = (0, import_babel_chain.createBabelChain)();
  const disableEnvPreset = typeof envOptions === "boolean" && !envOptions;
  const disableReactPreset = typeof reactOptions === "boolean" && !reactOptions;
  const disableTypescriptPreset = typeof typescriptOptions === "boolean" && !typescriptOptions;
  if (!disableEnvPreset) {
    const browsersTargets = syntax === "es5" ? (0, import_utils.getBrowserslist)(appDirectory) : es6BrowserList;
    const targets = runEnvironments === "node" ? {
      node: "12"
    } : browsersTargets;
    const presetEnvOptions = {
      targets: overrideBrowserslist || targets,
      modules: type === "commonjs" ? "commonjs" : false,
      bugfixes: runEnvironments !== "node",
      shippedProposals: type === "module" && syntax === "es6+",
      ...getPresetOptions(envOptions)
    };
    chain.preset("@babel/preset-env").use(require.resolve("@babel/preset-env"), [
      presetEnvOptions
    ]);
  }
  if (!disableReactPreset) {
    const classicOption = {
      useBuiltIns: !(type === "module" && syntax === "es5"),
      useSpread: type === "module" && syntax === "es5"
    };
    const automaticOption = {};
    const presetReactOptions = {
      runtime: jsxTransformRuntime === "classic" ? "classic" : "automatic",
      ...jsxTransformRuntime === "classic" ? classicOption : automaticOption,
      ...getPresetOptions(reactOptions)
    };
    chain.preset("@babel/preset-react").use(require.resolve("@babel/preset-react"), [
      presetReactOptions
    ]);
  }
  if (!(useTsLoader || disableTypescriptPreset)) {
    const typescriptPresetOptions = {
      ...import_utils.DEFAULT_BABEL_PRESET_TYPESCRIPT_OPTIONS,
      ...getPresetOptions(typescriptOptions)
    };
    chain.preset("@babel/preset-typescript").use(require.resolve("@babel/preset-typescript"), [
      typescriptPresetOptions
    ]);
  }
  return chain;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getPresetChain
});
